/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import com.rjconsultores.ventaboletos.entidad.TipoParada;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoParada;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaTipoParadaController")
@Scope("prototype")
public class BusquedaTipoParadaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoParada> plwTipoParada;
    private MyListbox tipoParadaList;
    private Paging pagingTipoParada;
    private Textbox txtNombre;

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoParada(new TipoParada());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tipoParadaList.setItemRenderer(new RenderTipoParada());
        tipoParadaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoParada c = (TipoParada) tipoParadaList.getSelected();
                verTipoParada(c);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verTipoParada(TipoParada c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tipoParada", c);
        args.put("tipoParadaList", tipoParadaList);

        openWindow("/gui/esquema_operacional/editarTipoParada.zul",
                Labels.getLabel("busquedaTipoParadaController.window.title"), args, MODAL);
    }

    private void refreshLista() throws InterruptedException {
        HibernateSearchObject<TipoParada> tipoParadaBusqueda =
                new HibernateSearchObject<TipoParada>(TipoParada.class, pagingTipoParada.getPageSize());

        tipoParadaBusqueda.addFilterLike("desctipo", "%" + txtNombre.getText().trim().concat("%"));
        tipoParadaBusqueda.addFilterEqual("activo", Boolean.TRUE);
        tipoParadaBusqueda.addSortAsc("desctipo");

        plwTipoParada.init(tipoParadaBusqueda, tipoParadaList, pagingTipoParada);

        if (tipoParadaList.getData().length == 0) {
            Messagebox.show(
                    Labels.getLabel("MSG.ningunRegistro"),
                    Labels.getLabel("busquedaTipoParadaController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);
        }
    }
}
